/**
 * Copyright (C) 2011, BMW AG
 *
 * GeniviAudioMananger AudioManagerDaemon
 *
 * \file CommonFunctions.h
 *
 * \date 20-Oct-2011 3:42:04 PM
 * \author Christian Mueller (christian.ei.mueller@bmw.de)
 *
 * \section License
 * GNU Lesser General Public License, version 2.1, with special exception (GENIVI clause)
 * Copyright (C) 2011, BMW AG Christian Mueller  Christian.ei.mueller@bmw.de
 *
 * This program is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License, version 2.1, as published by the Free Software Foundation.
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License, version 2.1, for more details.
 * You should have received a copy of the GNU Lesser General Public License, version 2.1, along with this program; if not, see <http://www.gnu.org/licenses/lgpl-2.1.html>.
 * Note that the copyright holders assume that the GNU Lesser General Public License, version 2.1, may also be applicable to programs even in cases in which the program is not a library in the technical sense.
 * Linking AudioManager statically or dynamically with other modules is making a combined work based on AudioManager. You may license such other modules under the GNU Lesser General Public License, version 2.1. If you do not want to license your linked modules under the GNU Lesser General Public License, version 2.1, you may use the program under the following exception.
 * As a special exception, the copyright holders of AudioManager give you permission to combine AudioManager with software programs or libraries that are released under any license unless such a combination is not permitted by the license of such a software program or library. You may copy and distribute such a system following the terms of the GNU Lesser General Public License, version 2.1, including this special exception, for AudioManager and the licenses of the other code concerned.
 * Note that people who make modified versions of AudioManager are not obligated to grant this special exception for their modified versions; it is their choice whether to do so. The GNU Lesser General Public License, version 2.1, gives permission to release a modified version without this exception; this exception also makes it possible to release a modified version which carries forward this exception.
 *
 * THIS CODE HAS BEEN GENERATED BY ENTERPRISE ARCHITECT GENIVI MODEL. PLEASE CHANGE ONLY IN ENTERPRISE ARCHITECT AND GENERATE AGAIN
 */

#ifndef COMMONHEADERS_H_
#define COMMONHEADERS_H_

#include "audiomanagertypes.h"

namespace am
{

class CommonFunctions
{
public:

    static std::vector<am_ConnectionFormat_e> getStandardConnectionFormatList();
    static std::vector<am_SoundProperty_s> getStandardSoundPropertyList();
    static std::vector<am_MainSoundProperty_s> getStandardMainSoundPropertyList();
    static std::vector<bool> getStandardConvertionMatrix();
    bool compareSource(std::vector<am_Source_s>::iterator listIterator, const am_Source_s& sourceData);
    bool compareSink(std::vector<am_Sink_s>::iterator listIterator, const am_Sink_s& sinkData);
    bool compareGateway(std::vector<am_Gateway_s>::iterator listIterator, const am_Gateway_s& gatewayData);
    bool compareGateway1(const am_Gateway_s gateway1, const am_Gateway_s gatewayData);
    bool compareSinkMainSink(std::vector<am_SinkType_s>::iterator listIterator, const std::vector<am_Sink_s>& sinkList);
    bool compareSinkMainSource(std::vector<am_SourceType_s>::iterator listIterator, const std::vector<am_Source_s>& sourceList);
    bool compareRoute(am_Route_s a, am_Route_s b);
    void createSink(am_Sink_s& sink) const;
    void createSource(am_Source_s& source) const;
    void createDomain(am_Domain_s& domain) const;
    void createGateway(am_Gateway_s& gateway);
    void createConnection(am_Connection_s& connection) const;
    void createMainConnection(am_MainConnection_s& mainConnection, am_Route_s route) const;
    void connectionList2RoutingList(std::vector<am_RoutingElement_s>& routingList, const std::vector<am_Connection_s>& connectionList);

    struct sortBySinkID
    {
        bool operator()(const am_RoutingElement_s & a, const am_RoutingElement_s & b) const
        {
            return (a.sinkID < b.sinkID);
        }
    };

    struct sortByConnectionFormat
    {
        bool operator()(const am_ConnectionFormat_e & a, const am_ConnectionFormat_e & b) const
        {
            return (a < b);
        }
    };

    struct sortByMainSoundProperty
    {
        bool operator()(const am_MainSoundProperty_s & a, const am_MainSoundProperty_s & b) const
        {
            return (a.type > b.type);
        }
    };

    struct sortBySoundProperty
    {
        bool operator()(const am_SoundProperty_s & a, const am_SoundProperty_s & b) const
        {
            return (a.type < b.type);
        }
    };
};

}

#endif /* COMMONHEADERS_H_ */
